Scriptname BahloknehviirConfigMenu extends SKI_ConfigBase  

GlobalVariable Property s0680535_BahloknehviirVampireSouls  Auto  
GlobalVariable Property s0680535_DragonsKilledbyBahloknehviir  Auto  
GlobalVariable Property s0680535_BahloknehviirDaedraSouls  Auto  

GlobalVariable Property s0680535_BahloknehviirAbilityDrain  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityDaedricLaceration  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityUnstoppable  Auto  

GlobalVariable Property s0680535_BahloknehviirAbilityUnseenEviscerator  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityInsatiableWeapon  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityTyrannousThuum  Auto  

GlobalVariable Property s0680535_BahloknehviirAbilityUntouchable  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityMadness  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityDraconicHammer  Auto  

GlobalVariable Property s0680535_BahloknehviirAbilityBlackrazor  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilitySoulReaver  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityNoneAreSafe  Auto  

GlobalVariable Property s0680535_BahloknehviirAbilityTheBlackSword  Auto  

GlobalVariable Property s0680535_NPCExpMult  Auto
GlobalVariable Property s0680535_Rumors  Auto  
GlobalVariable Property s0680535_UnspokenStorm  Auto  
GlobalVariable Property s0680535_BahloknehviirHunger  Auto  
GlobalVariable Property s0680535_Delay  Auto  

Int Property OneDrainOID  Auto  
Int Property OneLacerationOID  Auto  
Int Property OneUnstoppableOID  Auto  

Int Property TwoEvisceratorOID  Auto  
Int Property TwoInsatiableOID  Auto  
Int Property TwoTyrannousOID  Auto  

Int Property ThreeEtherealOID  Auto  
Int Property ThreeVigorOID  Auto  
Int Property ThreeHammerOID  Auto  

Int Property FourBlackrazorOID  Auto  
Int Property FourSoulreaverOID  Auto  
Int Property FourNonearesafeOID  Auto  

Int Property FinalDuaniikrahOID  Auto  

Int Property DragonKillsOID_S Auto
Int Property DaedraKillsOID_S Auto
Int Property VampireKillsOID_S Auto
Int Property ExpMultOID_S Auto
Int Property RumorsOID_S Auto
Int Property DelayOID_S Auto
Float Property DelayVal Auto

Bool FinalQuestVal = false
Bool OneDrainVal  = false
Bool OneLacerationVal = false
Bool OneUnstoppableVal  = false
Bool TwoEvisceratorVal  = false
Bool TwoInsatiableVal  = false
Bool TwoTyrannousVal = false
Bool ThreeEtherealVal = false
Bool ThreeVigorVal = false
Bool ThreeHammerVal = false
Bool FourBlackrazorVal = false
Bool FourSoulreaverVal = false
Bool FourNonearesafeVal = false
Bool FinalDuaniikrahVal = false

Perk Property s0680535_DevourerPassives  Auto

;Race Property DLC1VampireBeastRace  Auto   

ReferenceAlias Property SwordmansJournal  Auto  

;SPELL Property s0680535_SummonBahloknehviirLocation  Auto  
;SPELL Property BMVLSpell1  Auto  

WEAPON Property VM_DEVOURER  Auto  

Int Property InfamyOID_M Auto
String[] InfamyList
int InfamyIndex

;int DebugOption_T
;bool DebugSetting

Quest Property s0680535_BahloknehviirQuest  Auto  
Quest Property s0680535_BahloknehviirQuestUnspoken  Auto  

event OnPageReset(string page)
	{Called when a new page is selected, including the initial empty page}
	Maintenance()
	FinalQuestVal = false
	
	InfamyList = new string[10]
	InfamyList[0] = "Unknown"
	InfamyList[1] = "Rumored"
	InfamyList[2] = "Known"
	InfamyList[3] = "Storied"
	InfamyList[4] = "Sought after"
	InfamyList[5] = "Infamous"
	InfamyList[6] = "Hunted"
	InfamyList[7] = "Feared"
	InfamyList[8] = "Terror of Skyrim"
	InfamyList[9] = "Dark Legend"

	if(s0680535_Rumors.GetValue() < 5)
		InfamyIndex = 0
	elseif(s0680535_Rumors.GetValue() >= 5) && (s0680535_Rumors.GetValue() < 15)
		InfamyIndex = 1
	elseif(s0680535_Rumors.GetValue() >= 15) && (s0680535_Rumors.GetValue() < 30)
		InfamyIndex = 2
	elseif(s0680535_Rumors.GetValue() >= 30) && (s0680535_Rumors.GetValue() < 45)
		InfamyIndex = 3
	elseif(s0680535_Rumors.GetValue() >= 45) && (s0680535_Rumors.GetValue() < 60)
		InfamyIndex = 4
	elseif(s0680535_Rumors.GetValue() >= 60) && (s0680535_Rumors.GetValue() < 80)
		InfamyIndex = 5
	elseif(s0680535_Rumors.GetValue() >= 80) && (s0680535_Rumors.GetValue() < 100)
		InfamyIndex = 6
	elseif(s0680535_Rumors.GetValue() >= 100) && (s0680535_Rumors.GetValue() < 125)
		InfamyIndex = 7
	elseif(s0680535_Rumors.GetValue() >= 125) && (s0680535_Rumors.GetValue() < 150)
		InfamyIndex = 8
	elseif(s0680535_Rumors.GetValue() >= 150)
		InfamyIndex = 9
	endif

	if (page == "Souls Devoured")
		if (Game.GetPlayer().HasPerk(s0680535_DevourerPassives) && s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 0.01)
			SetCursorFillMode(TOP_TO_BOTTOM)
			if((SwordmansJournal.GetReference().GetBaseObject() as book).IsRead())
				AddHeaderOption("Bahlok Neh Viir")
			else
				AddHeaderOption("The Black Sword")
			endif
			
			SetCursorPosition(2)
			AddHeaderOption("Favoured Prey Consumption")

			int flags = OPTION_FLAG_DISABLED
			SetCursorPosition(4)
			VampireKillsOID_S = AddSliderOption("Diableric Fervor:", s0680535_BahloknehviirVampireSouls.GetValue(), "{2} % Awakened", flags)
			SetCursorPosition(6)
			DaedraKillsOID_S = AddSliderOption("Daedric Gluttony:", s0680535_BahloknehviirDaedraSouls.GetValue(), "{2} % Satiated", flags)
			SetCursorPosition(8)
			DragonKillsOID_S = AddSliderOption("Draconic Wrath:", s0680535_DragonsKilledbyBahloknehviir.GetValue(), "{2} % Incited", flags)

			SetCursorPosition(12)
			AddHeaderOption("Statistics")
			SetCursorPosition(14)
			ExpMultOID_S = AddSliderOption("Aspect Multiplier:", s0680535_NPCExpMult.GetValue(), "{2} X", flags)
			SetCursorPosition(16)
			RumorsOID_S = AddSliderOption("Witnesses:", s0680535_Rumors.GetValue() as int, "{2} Lived to tell", flags)
			SetCursorPosition(18)
			InfamyOID_M = AddMenuOption("Infamy of the Blade:", InfamyList[InfamyIndex], flags)
			SetCursorPosition(20)
			DelayOID_S = AddSliderOption("Script delay:", DelayVal, "{1} Seconds")

		elseif ((Game.GetPlayer().HasPerk(s0680535_DevourerPassives)) && (s0680535_DragonsKilledbyBahloknehviir.GetValue() < 0.01))
			SetCursorPosition(0)
			AddHeaderOption("The blade is dormant.")
			SetCursorPosition(2)
			AddHeaderOption("It's favourite prey,")
			SetCursorPosition(4)
			AddHeaderOption("May awaken it.")
			SetCursorPosition(6)
			DelayOID_S = AddSliderOption("Script delay:", DelayVal, "{1} Seconds")

		else
			SetCursorPosition(0)
			AddHeaderOption("The blade waits...")	
		endif

	elseif (page == "Abilities")
		if(s0680535_BahloknehviirQuestUnspoken.GetStage() >= 100 && s0680535_BahloknehviirQuestUnspoken.GetStage() < 190)
			SetCursorFillMode(TOP_TO_BOTTOM)
			AddHeaderOption("DIE")
			SetCursorPosition(2)
			AddHeaderOption("DIE")
			SetCursorPosition(4)
			AddHeaderOption("DIE")
			FinalQuestVal = true

		elseif(((s0680535_BahloknehviirVampireSouls.GetValue() >= 5) || (s0680535_BahloknehviirDaedraSouls.GetValue() >= 5) || (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 5)) && (Game.GetPlayer().HasPerk(s0680535_DevourerPassives)))
			SetCursorFillMode(TOP_TO_BOTTOM)
			AddHeaderOption("Least Abilities")
		
			if(s0680535_BahloknehviirVampireSouls.GetValue() >= 5) && (FinalQuestVal == false)
				SetCursorPosition(2)
				OneDrainOID = AddToggleOption("Vampiric: Sanguine Sundering", OneDrainVal)
			endif

			if(s0680535_BahloknehviirDaedraSouls.GetValue() >= 5) && (FinalQuestVal == false)
				SetCursorPosition(4)
				OneLacerationOID = AddToggleOption("Daedric: Daedric Laceration", OneLacerationVal)
			endif
		
			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 5) && (FinalQuestVal == false)
				SetCursorPosition(6)
				OneUnstoppableOID = AddToggleOption("Draconic: Elemental Censure", OneUnstoppableVal)
			endif
	
		elseif((Game.GetPlayer().HasPerk(s0680535_DevourerPassives)) && (s0680535_DragonsKilledbyBahloknehviir.GetValue() < 0.01))
			SetCursorPosition(0)
			AddHeaderOption("The blade is dormant.")
			SetCursorPosition(2)
			AddHeaderOption("It's favourite prey,")
			SetCursorPosition(4)
			AddHeaderOption("May awaken it.")

		elseif((Game.GetPlayer().HasPerk(s0680535_DevourerPassives)) && (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 0.01) && (s0680535_BahloknehviirVampireSouls.GetValue() < 5) && (s0680535_BahloknehviirDaedraSouls.GetValue() < 5) && (s0680535_DragonsKilledbyBahloknehviir.GetValue() < 5))
			SetCursorPosition(0)
			AddHeaderOption("Appetite aroused,")
			SetCursorPosition(2)
			AddHeaderOption("Mortals will ease it's hunger,")
			SetCursorPosition(4)
			AddHeaderOption("Ancient Souls enhance the blade.")

		else
			SetCursorPosition(0)
			AddHeaderOption("The blade waits...")

		endif

		if((s0680535_BahloknehviirVampireSouls.GetValue() >= 10) || (s0680535_BahloknehviirDaedraSouls.GetValue() >= 10) || (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 10))
			SetCursorPosition(10)
			AddHeaderOption("Lesser Abilities")

			if(s0680535_BahloknehviirVampireSouls.GetValue() >= 10) && (FinalQuestVal == false)
				SetCursorPosition(12)
				TwoEvisceratorOID = AddToggleOption("Vampiric: Unseen Eviscerator", TwoEvisceratorVal)
			endif

			if(s0680535_BahloknehviirDaedraSouls.GetValue() >= 10) && (FinalQuestVal == false)
				SetCursorPosition(14)
				TwoInsatiableOID = AddToggleOption("Daedric: Insatiable Predator", TwoInsatiableVal)
			endif

			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 10) && (FinalQuestVal == false)
				SetCursorPosition(16)
				TwoTyrannousOID = AddToggleOption("Draconic: Tyrannous Thu'um", TwoTyrannousVal)
			endif
		endif

		if((s0680535_BahloknehviirVampireSouls.GetValue() >= 20) || (s0680535_BahloknehviirDaedraSouls.GetValue() >= 20) || (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 20))
			SetCursorPosition(1)
			AddHeaderOption("Greater Abilities")

			if(s0680535_BahloknehviirVampireSouls.GetValue() >= 20) && (FinalQuestVal == false)
				SetCursorPosition(3)
				ThreeEtherealOID = AddToggleOption("Vampiric: Ethereal Bastion", ThreeEtherealVal)
			endif
		
			if(s0680535_BahloknehviirDaedraSouls.GetValue() >= 20) && (FinalQuestVal == false)
				SetCursorPosition(5)
				ThreeVigorOID = AddToggleOption("Daedric: Daedric Shackles", ThreeVigorVal)
			endif

			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 20) && (FinalQuestVal == false)
				SetCursorPosition(7)
				ThreeHammerOID = AddToggleOption("Draconic: Draconic Hammer", ThreeHammerVal)
			endif
		endif

		if((s0680535_BahloknehviirVampireSouls.GetValue() >= 40) || (s0680535_BahloknehviirDaedraSouls.GetValue() >= 40) || (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 40))
			SetCursorPosition(11)
			AddHeaderOption("Dark Abilities")

			if(s0680535_BahloknehviirVampireSouls.GetValue() >= 40) && (FinalQuestVal == false)
				SetCursorPosition(13)
				FourBlackrazorOID = AddToggleOption("Vampiric: Blackrazor", FourBlackrazorVal)
			endif

			if(s0680535_BahloknehviirDaedraSouls.GetValue() >= 40) && (FinalQuestVal == false)
				SetCursorPosition(15)
				FourSoulreaverOID = AddToggleOption("Daedric: Soul Reaver", FourSoulreaverVal)
			endif

			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 40) && (FinalQuestVal == false)
				SetCursorPosition(17)
				FourNonearesafeOID = AddToggleOption("Draconic: The Black Sword", FourNonearesafeVal)
			endif
		endif

		if((s0680535_BahloknehviirVampireSouls.GetValue() >= 100) && (s0680535_BahloknehviirDaedraSouls.GetValue() >= 100) && (s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 100) && ((SwordmansJournal.GetReference().GetBaseObject() as book).IsRead()) && (s0680535_UnspokenStorm.GetValue() == 1) && (FinalQuestVal == false))
			SetCursorPosition(21)
			AddHeaderOption("Darkest Ability")
			SetCursorPosition(23)
			FinalDuaniikrahOID = AddToggleOption("Unspoken: Stormbringer", FinalDuaniikrahVal)
		endif
	
	;elseif (page == "Debug ")
		;DebugOption_T = AddTextOption("Install/Uninstall", DebugSetting)
	; Load custom .swf for animated logo that's displayed when no page is selected yet.
	;elseif (page == "")
	;	LoadCustomContent("ASwordAcursed/ConfigMenuImage.dds", 376,223)
	;	return
	;else
	;	UnloadCustomContent()
	endIf
endEvent

event OnOptionSelect(int option)
	{Called when a non-interactive option has been selected}
	;LEAST ABILITIES
	if(option == OneDrainOID)
		OneDrainVal = !OneDrainVal
		s0680535_BahloknehviirAbilityDrain.SetValue(OneDrainVal as float)
		SetToggleOptionValue(OneDrainOID, OneDrainVal)

		OneLacerationVal = false
		SetToggleOptionValue(OneLacerationOID, OneLacerationVal)
		s0680535_BahloknehviirAbilityDaedricLaceration.SetValue(OneLacerationVal as float)

		OneUnstoppableVal = false
		s0680535_BahloknehviirAbilityUnstoppable.SetValue(OneUnstoppableVal as float)
		SetToggleOptionValue(OneUnstoppableOID, OneUnstoppableVal)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == OneLacerationOID)
		OneLacerationVal = !OneLacerationVal
		s0680535_BahloknehviirAbilityDaedricLaceration.SetValue(OneLacerationVal as float)
		SetToggleOptionValue(OneLacerationOID, OneLacerationVal)
		
		OneDrainVal = false
		s0680535_BahloknehviirAbilityDrain.SetValue(OneDrainVal as float)
		SetToggleOptionValue(OneDrainOID,OneDrainVal)
		
		OneUnstoppableVal = false
		s0680535_BahloknehviirAbilityUnstoppable.SetValue(OneUnstoppableVal as float)
		SetToggleOptionValue(OneUnstoppableOID, OneUnstoppableVal)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == OneUnstoppableOID)
		OneUnstoppableVal = !OneUnstoppableVal
		s0680535_BahloknehviirAbilityUnstoppable.SetValue(OneUnstoppableVal as float)
		SetToggleOptionValue(OneUnstoppableOID, OneUnstoppableVal)
		
		OneDrainVal = false
		s0680535_BahloknehviirAbilityDrain.SetValue(OneDrainVal as float)
		SetToggleOptionValue(OneDrainOID,OneDrainVal)
		
		OneLacerationVal = false
		s0680535_BahloknehviirAbilityDaedricLaceration.SetValue(OneLacerationVal as float)
		SetToggleOptionValue(OneLacerationOID, OneLacerationVal)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	;LESSER ABILITIES
	elseif(option == TwoEvisceratorOID)
		TwoEvisceratorVal = !TwoEvisceratorVal
		s0680535_BahloknehviirAbilityUnseenEviscerator.SetValue(TwoEvisceratorVal as float)
		SetToggleOptionValue(TwoEvisceratorOID, TwoEvisceratorVal)

		TwoInsatiableVal = false
		s0680535_BahloknehviirAbilityInsatiableWeapon.SetValue(TwoInsatiableVal as float)
		SetToggleOptionValue(TwoInsatiableOID, TwoInsatiableVal)

		TwoTyrannousVal = false
		SetToggleOptionValue(TwoTyrannousOID, TwoTyrannousVal)
		s0680535_BahloknehviirAbilityTyrannousThuum.SetValue(TwoTyrannousVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == TwoInsatiableOID)
		TwoInsatiableVal = !TwoInsatiableVal 
		s0680535_BahloknehviirAbilityInsatiableWeapon.SetValue(TwoInsatiableVal as float)
		SetToggleOptionValue(TwoInsatiableOID, TwoInsatiableVal)

		TwoEvisceratorVal = false
		s0680535_BahloknehviirAbilityUnseenEviscerator.SetValue(TwoEvisceratorVal as float)
		SetToggleOptionValue(TwoEvisceratorOID, TwoEvisceratorVal)

		TwoTyrannousVal = false
		SetToggleOptionValue(TwoTyrannousOID, TwoTyrannousVal)
		s0680535_BahloknehviirAbilityTyrannousThuum.SetValue(TwoTyrannousVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == TwoTyrannousOID)
		TwoTyrannousVal = !TwoTyrannousVal
		SetToggleOptionValue(TwoTyrannousOID, TwoTyrannousVal)
		s0680535_BahloknehviirAbilityTyrannousThuum.SetValue(TwoTyrannousVal as float)
	
		TwoEvisceratorVal = false
		s0680535_BahloknehviirAbilityUnseenEviscerator.SetValue(TwoEvisceratorVal as float)
		SetToggleOptionValue(TwoEvisceratorOID, TwoEvisceratorVal)

		TwoInsatiableVal = false
		s0680535_BahloknehviirAbilityInsatiableWeapon.SetValue(TwoInsatiableVal as float)
		SetToggleOptionValue(TwoInsatiableOID, TwoInsatiableVal)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	;GREATER ABILITIES
	elseif(option == ThreeEtherealOID)
		ThreeEtherealVal = !ThreeEtherealVal
		SetToggleOptionValue(ThreeEtherealOID, ThreeEtherealVal)
		s0680535_BahloknehviirAbilityUntouchable.SetValue(ThreeEtherealVal as float)

		ThreeVigorVal = false
		SetToggleOptionValue(ThreeVigorOID, ThreeVigorVal)
		s0680535_BahloknehviirAbilityMadness.SetValue(ThreeVigorVal as float)

		ThreeHammerVal = false
		SetToggleOptionValue(ThreeHammerOID, ThreeHammerVal)
		s0680535_BahloknehviirAbilityDraconicHammer.SetValue(ThreeHammerVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == ThreeVigorOID)
		ThreeVigorVal = !ThreeVigorVal
		SetToggleOptionValue(ThreeVigorOID, ThreeVigorVal)
		s0680535_BahloknehviirAbilityMadness.SetValue(ThreeVigorVal as float)

		ThreeEtherealVal = false
		SetToggleOptionValue(ThreeEtherealOID, ThreeEtherealVal)
		s0680535_BahloknehviirAbilityUntouchable.SetValue(ThreeEtherealVal as float)

		ThreeHammerVal = false
		SetToggleOptionValue(ThreeHammerOID, ThreeHammerVal)
		s0680535_BahloknehviirAbilityDraconicHammer.SetValue(ThreeHammerVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == ThreeHammerOID)
		ThreeHammerVal = !ThreeHammerVal
		SetToggleOptionValue(ThreeHammerOID, ThreeHammerVal)
		s0680535_BahloknehviirAbilityDraconicHammer.SetValue(ThreeHammerVal as float)

		ThreeEtherealVal = false
		SetToggleOptionValue(ThreeEtherealOID, ThreeEtherealVal)
		s0680535_BahloknehviirAbilityUntouchable.SetValue(ThreeEtherealVal as float)

		ThreeVigorVal = false
		SetToggleOptionValue(ThreeVigorOID, ThreeVigorVal)
		s0680535_BahloknehviirAbilityMadness.SetValue(ThreeVigorVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	;DARK ABILITIES
	elseif(option == FourBlackrazorOID)
		FourBlackrazorVal = !FourBlackrazorVal
		SetToggleOptionValue(FourBlackrazorOID, FourBlackrazorVal)
		s0680535_BahloknehviirAbilityBlackrazor.SetValue(FourBlackrazorVal as float)

		FourSoulreaverVal = false
		SetToggleOptionValue(FourSoulreaverOID, FourSoulreaverVal)
		s0680535_BahloknehviirAbilitySoulReaver.SetValue(FourSoulreaverVal as float)
	
		FourNonearesafeVal = false
		SetToggleOptionValue(FourNonearesafeOID, FourNonearesafeVal)
		s0680535_BahloknehviirAbilityNonearesafe.SetValue(FourNonearesafeVal as float)
		
		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == FourSoulreaverOID)
		FourSoulreaverVal = !FourSoulreaverVal
		SetToggleOptionValue(FourSoulreaverOID, FourSoulreaverVal)
		s0680535_BahloknehviirAbilitySoulReaver.SetValue(FourSoulreaverVal as float)
		
		FourBlackrazorVal = false
		SetToggleOptionValue(FourBlackrazorOID, FourBlackrazorVal)
		s0680535_BahloknehviirAbilityBlackrazor.SetValue(FourBlackrazorVal as float)

		FourNonearesafeVal = false
		SetToggleOptionValue(FourNonearesafeOID, FourNonearesafeVal)
		s0680535_BahloknehviirAbilityNonearesafe.SetValue(FourNonearesafeVal as float)

		FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	elseif(option == FourNonearesafeOID)
		FourNonearesafeVal = !FourNonearesafeVal
		SetToggleOptionValue(FourNonearesafeOID, FourNonearesafeVal)
		s0680535_BahloknehviirAbilityNonearesafe.SetValue(FourNonearesafeVal as float)

		FourBlackrazorVal = false
		SetToggleOptionValue(FourBlackrazorOID, FourBlackrazorVal)
		s0680535_BahloknehviirAbilityBlackrazor.SetValue(FourBlackrazorVal as float)

		FourSoulreaverVal = false
		SetToggleOptionValue(FourSoulreaverOID, FourSoulreaverVal)
		s0680535_BahloknehviirAbilitySoulReaver.SetValue(FourSoulreaverVal as float)
		
		 FinalDuaniikrahVal = false
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)

	;DARKEST ABILITY
	elseif(option == FinalDuaniikrahOID)
		FinalDuaniikrahVal = !FinalDuaniikrahVal
		SetToggleOptionValue(FinalDuaniikrahOID, FinalDuaniikrahVal)
		s0680535_BahloknehviirAbilityTheBlackSword.SetValue(FinalDuaniikrahVal as float)
		FourSoulreaverVal = true
		SetToggleOptionValue(FourSoulreaverOID, FourSoulreaverVal)
		s0680535_BahloknehviirAbilitySoulReaver.SetValue(FourSoulreaverVal as float)
		FourBlackrazorVal = true
		SetToggleOptionValue(FourBlackrazorOID, FourBlackrazorVal)
		s0680535_BahloknehviirAbilityBlackrazor.SetValue(FourBlackrazorVal as float)
		FourNonearesafeVal = true
		SetToggleOptionValue(FourNonearesafeOID, FourNonearesafeVal)
		s0680535_BahloknehviirAbilityNonearesafe.SetValue(FourNonearesafeVal as float)
		ThreeVigorVal = true
		SetToggleOptionValue(ThreeVigorOID, ThreeVigorVal)
		s0680535_BahloknehviirAbilityMadness.SetValue(ThreeVigorVal as float)
		ThreeEtherealVal = true
		SetToggleOptionValue(ThreeEtherealOID, ThreeEtherealVal)
		s0680535_BahloknehviirAbilityUntouchable.SetValue(ThreeEtherealVal as float)
		ThreeHammerVal = true
		SetToggleOptionValue(ThreeHammerOID, ThreeHammerVal)
		s0680535_BahloknehviirAbilityDraconicHammer.SetValue(ThreeHammerVal as float)
		TwoEvisceratorVal = true
		s0680535_BahloknehviirAbilityUnseenEviscerator.SetValue(TwoEvisceratorVal as float)
		SetToggleOptionValue(TwoEvisceratorOID, TwoEvisceratorVal)
		TwoTyrannousVal = true
		SetToggleOptionValue(TwoTyrannousOID, TwoTyrannousVal)
		s0680535_BahloknehviirAbilityTyrannousThuum.SetValue(TwoTyrannousVal as float)
		TwoInsatiableVal = true
		s0680535_BahloknehviirAbilityInsatiableWeapon.SetValue(TwoInsatiableVal as float)
		SetToggleOptionValue(TwoInsatiableOID, TwoInsatiableVal)
		OneLacerationVal = true
		SetToggleOptionValue(OneLacerationOID, OneLacerationVal)
		s0680535_BahloknehviirAbilityDaedricLaceration.SetValue(OneLacerationVal as float)
		OneUnstoppableVal = true
		s0680535_BahloknehviirAbilityUnstoppable.SetValue(OneUnstoppableVal as float)
		SetToggleOptionValue(OneUnstoppableOID, OneUnstoppableVal)
		OneDrainVal = true
		s0680535_BahloknehviirAbilityDrain.SetValue(OneDrainVal as float)
		SetToggleOptionValue(OneDrainOID,OneDrainVal)

	;elseif(option == DebugOption_T)
	;	DebugSetting != DebugSetting
	;	SetTextOptionValue(DebugOption_T, DebugSetting)
	;	if DebugSetting == 0
	;		s0680535_BahloknehviirQuest.Stop()
	;		Game.GetPlayer().RemovePerk(s0680535_DevourerPassives)
	;	elseif DebugSetting == 1
	;		s0680535_BahloknehviirQuest.Start()
	;	endif
	endif

endEvent

event OnOptionSliderOpen(int option)
	
	if (option == DelayOID_S)
		SetSliderDialogStartValue(2.0)
      		SetSliderDialogDefaultValue(2.0)
       	SetSliderDialogRange(1.0, 40.0)
       	SetSliderDialogInterval(0.5)
	endif

endEvent

event OnOptionSliderAccept(int option, float value)

	if (option == DelayOID_S)
		DelayVal = value
		SetSliderOptionValue(DelayOID_S, DelayVal, "{1} Seconds")
		s0680535_Delay.SetValue(DelayVal)
	endif

endEvent

event OnOptionHighlight(int option)
	if (option == OneDrainOID)
		SetInfoText("Steal the lifeforce of your victims. If you are a vampire with 'Blood of the Ancients,' you can also leech Critical Chance and Movement Speed.")

	elseif(option == OneLacerationOID)
		SetInfoText("Inflict terrible bleeding wounds to your foes. Such wounds can sometimes leave an enemy helpless for a short time.")

	elseif(option == OneUnstoppableOID)
		SetInfoText("Inflict poison, time and reaping damage simultaneously depending on how satiated the blade is. Poison deals little damage but gets worse with time. Time deals no direct damage but weakens mortal enemies by reducing their attack speed and damage resistance. Reaping deals damage to health but also negates health regeneration and healing for a time.")

	elseif(option == TwoEvisceratorOID)
		SetInfoText("The blade gradually moulds its wielder into the ultimate predator. Sneak attack damage increases depending on Magicka remaining.")

	elseif(option == TwoInsatiableOID)
		SetInfoText("Each cut delivered has a chance to trigger a burst of great speed whereby time slows down and attack speed increases for 2 seconds. Magnitude increases if the sword is well-fed, but chance of activation greatly increases when starving.")

	elseif(option == TwoTyrannousOID)
		SetInfoText("Feeding the sword reduces shout cooldown time to zero for a short time.")

	elseif(option == ThreeEtherealOID)
		SetInfoText("When blocking, the sword may cause you to assume an intangible form when attacked, rendering you invulnerable to physical and magical attacks for 2 seconds. However, this drains Magicka each time. Magicka drain can be alleviated somewhat by devouring more Vampire souls.")

	elseif(option == ThreeVigorOID)
		SetInfoText("Bashing sends a bolt of Daedric energy towards the target. Enemies struck by the bolt are instantly teleported in front you, well within the sword's reach. If you are sneaking when bashing or if the enemy cannot be moved, you will be teleported behind the enemy. This ability drains Magicka however the cost can be reduced by devouring more Daedra.")

	elseif(option == ThreeHammerOID)
		SetInfoText("The strength of consumed Dragon Souls allows your power-attacks to hurl your enemies back with collosal force even if the blade doesn't touch them! The force of the knockback effect increases with every Dragon Soul devoured. Each power-attack drains Magicka.")

	elseif(option == FourBlackrazorOID)
		SetInfoText("Upon consuming a mortal soul you are granted a bonus depending on the type of soul. Bonuses stack and last for 1 hour. The strength of the bonus increases with when the sword is satiated. Furthermore, killing powerful enemies fully restores your health and triggers a burst of blinding speed where time appears to stand still for 4 seconds. BONUS: Having all vampiric abilities active allows the sword to drink the sun's light and darken the sky if drawn during daylight hours.")
	
	elseif(option == FourSoulreaverOID)
		SetInfoText("Each attack absorbs the target's Magicka and Stamina. Enemies drained of Magicka and Stamina may find their skills and memories leeched to feed the sword. BONUS: Having all Daedric abilities active wreathes you in eldritch flames which add 10-60% to your magic resistance, depending on how well-fed the sword is.")

	elseif(option == FourNonearesafeOID)
		SetInfoText("Attacks cut through both magical and mundane protections as if they were paper. BONUS: Having all Draconic abilities active allows power-attacks to cripple Dragons for a time, forcing them to remain grounded.")

	elseif(option == FinalDuaniikrahOID)
		SetInfoText("Activating this ability simultaneously activates all previous abilities. None can stand against Bahlok Neh Viir's power now. Every cut delivered to the sword's prey has a chance, based on how satiated the sword is, to kill. Only the strongest enemies can endure, but even they suffer crippling wounds. Such is the sword's power that reality itself is warped with each swing as small portals to the dark place where the sword hails from are opened and ghostly swords rain down upon your current target. Enemies killed by these swords will feed the blade. However, wielding the sword in it's fully awakened state puts an incredible strain on your concentration, causing your magicka to drain rapidly.")
	
	elseif(option == DelayOID_S)
		SetInfoText("Set how often the script controlling sword hunger updates. Lower values means higher quicker updating, whereas higher values put less strain on performance. Default = 2.")
	endIf


endEvent

;Event OnInit()
;	Maintenance()
;EndEvent

Function Maintenance()
	actor target = Game.GetPlayer()
	
	if((target.GetEquippedWeapon() == VM_DEVOURER) && (target.getactorvalue("rightitemcharge") < 1))
		s0680535_BahloknehviirHunger.SetValue(2)
		target.setactorvalue("rightitemcharge", s0680535_BahloknehviirHunger.GetValue())
	endif

	if((s0680535_BahloknehviirQuest.GetStage() >= 30) && (!Game.GetPlayer().HasPerk(s0680535_DevourerPassives)) && (s0680535_BahloknehviirQuestUnspoken.IsStageDone(190) == 1))
		target.AddPerk(s0680535_DevourerPassives)
	endif
EndFunction
