Scriptname s0680535_AcquireDevourer extends activemagiceffect  

Quest Property s0680535_BahloknehviirQuest  Auto  
Quest Property s0680535_BahloknehviirQuestUnspoken  Auto  
Quest Property GalkinQuest  Auto  

GlobalVariable Property s0680535_BahloknehviirHunger  Auto  
GlobalVariable Property s0680535_BahloknehviirHungerPercent  Auto  
GlobalVariable Property s0680535_BahloknehviirDragonSouls  Auto
GlobalVariable Property s0680535_BahloknehviirAbilityUntouchable  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilityMadness  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilityDraconicHammer  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilityDuaniikRah  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilitySoulReaver  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilityInsatiableWeapon  Auto  
;GlobalVariable Property s0680535_BahloknehviirAbilityDaedricLaceration  Auto  
GlobalVariable Property s0680535_BahloknehviirDaedraSouls  Auto
GlobalVariable Property s0680535_BahloknehviirVampireSouls  Auto
GlobalVariable Property s0680535_NPCExpMult  Auto
GlobalVariable Property s0680535_Rumors  Auto 
GlobalVariable Property s0680535_UnspokenStormActive  Auto  
GlobalVariable Property VLlevitate  Auto  
GlobalVariable Property s0680535_Delay  Auto  

FormList Property GhostWeaponFormList  Auto 
FormList Property VLSpellList  Auto   

Perk Property souldevourerpassives  Auto  
;Perk Property s0680535_PullPerk  Auto  
;Perk Property s0680535_DevourerSight  Auto  
;Perk Property s0680535_EtherealBastion  Auto  
;Perk Property s0680535_OblivionMastery Auto  
 
;SPELL Property detectsouls  Auto 
;SPELL Property detectsouls2  Auto  
;SPELL Property detectsouls3  Auto  
;SPELL Property StopTimeOnDeath  Auto
SPELL Property s0680535_DevourerPassives  Auto  
SPELL Property s0680535_BahloknehviirHealing  Auto  
SPELL Property s0680535_EtherealBastionSpell  Auto  
SPELL Property s0680535_DrainHealth  Auto
SPELL Property s0680535_SummonBahloknehviirLocation  Auto  
SPELL Property VLSpell1  Auto  

MagicEffect Property DevourerStart  Auto  

Message Property BahloknehviirComplete  Auto
Message Property BahloknehviirStarved  Auto
Message Property BahloknehviirRavenous  Auto  
Message Property BahloknehviirHungry  Auto  
Message Property BahloknehviirUnsatisfied  Auto  
Message Property BahloknehviirSatisfied  Auto  
Message Property BahloknehviirEngorged  Auto  
;Message Property BahloknehviirSustains  Auto  
Message Property VampiricPower  Auto  
Message Property DaedricPower  Auto  
Message Property DraconicPower  Auto  
Message Property NewPowerGained  Auto  

Race Property DLC1VampireBeastRace  Auto

ReferenceAlias Property s0680535_SwordsmansJournal  Auto  

Shout Property s0680535_SummonBahloknehviirShout  Auto  

WEAPON Property IronGreatsword  Auto 
WEAPON Property VM_DEVOURER_DUPLICATE  Auto   
WEAPON Property VM_DEVOURER  Auto
WEAPON Property VM_DEVOURER_LESSER  Auto  

WordOfPower Property Bahlok  Auto  
WordOfPower Property Neh  Auto  
WordOfPower Property Viir  Auto  

float GameTime1
float GameTime2
float HoursPassed

GlobalVariable Property wordsknown  Auto
GlobalVariable Property do1  Auto
GlobalVariable Property do2  Auto
GlobalVariable Property do3  Auto
GlobalVariable Property do4  Auto
GlobalVariable Property do5  Auto
GlobalVariable Property do6  Auto
GlobalVariable Property do7  Auto
GlobalVariable Property do8  Auto
GlobalVariable Property do9  Auto
GlobalVariable Property do10  Auto
GlobalVariable Property do11  Auto
GlobalVariable Property do12  Auto
GlobalVariable Property do13  Auto

;int TargetModIndex 
int basedamage
int moddamage

EVENT OnEffectStart(ACTOR target, ACTOR caster)
	
	GhostWeaponFormList.AddForm(VM_DEVOURER)
	GhostWeaponFormList.AddForm(VM_DEVOURER_DUPLICATE)
	GhostWeaponFormList.AddForm(VM_DEVOURER_LESSER)

	RegisterForSingleUpdateGameTime(1.0)	
	GameTime1 = Utility.GetCurrentGameTime() * 24

	while(target.HasMagicEffect(DevourerStart))
		GameTime2 = Utility.GetCurrentGameTime() *24		
		
		if (!Utility.IsInMenuMode())
			if((s0680535_BahloknehviirQuestUnspoken.GetStage() < 100) || (s0680535_BahloknehviirQuestUnspoken.IsStageDone(140)))
				BahloknehviirHungerManager(target)
				BahloknehviirAbilityManager(target)
			endif	
		endif

		if VLlevitate.GetValue() == 2
			VLSpellList.AddForm(s0680535_SummonBahloknehviirLocation)
			VLSpellList.AddForm(VLSpell1)
		else
			VLSpellList.Revert()
		endif

		if(target.GetEquippedWeapon() == VM_DEVOURER)
			basedamage = (IronGreatsword.GetBaseDamage()*0.7) as int 

			target.ForceActorValue("rightitemcharge", s0680535_BahloknehviirHunger.GetValue())		;Update weapon charge as weapon hunger progresses
			
			if ((s0680535_SwordsmansJournal.GetReference().GetBaseObject() as book).IsRead() == 1)
				VM_DEVOURER.SetName("Bahlok Neh Viir")
				;Debug.Notification("Changing Name")
			endif
			if(s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01)
				moddamage = (basedamage * (s0680535_BahloknehviirHunger.GetValue()/10000) + (s0680535_BahloknehviirHunger.GetValue()/600)) as int
				VM_DEVOURER.SetBaseDamage(moddamage)			;Update weapon base damage as sword is fed (starts out weaker than an iron greatsword, but when fully fed is stronger than a dragonbone greatsword)
			else
				VM_DEVOURER.SetBaseDamage(basedamage)
			endif

			if(target.GetActorValue("Magicka") < 1) || (target.GetEquippedWeapon() != VM_DEVOURER)
				target.RemoveItem(VM_DEVOURER, 99, true)
			endif
		endif
		
		if (s0680535_Delay != none) ;Delay has been set
			utility.wait(s0680535_Delay.GetValue())
		else
			utility.wait(5)
		endif
	endwhile

ENDEVENT

EVENT OnEffectFinish(ACTOR target, ACTOR caster)
	
	;s0680535_BahloknehviirQuest.Stop()
	;target.RemoveSpell(s0680535_DevourerPassives)
	;DispelBahloknehviirHungerEffects(target)
	;target.RemovePerk(souldevourerpassives)
	;target.RemovePerk(s0680535_DevourerSight)
	;target.RemovePerk(s0680535_PullPerk)
	;target.RemovePerk(s0680535_EtherealBastion)
	;target.RemoveSpell(s0680535_SummonBahloknehviirLocation)
	target.DispelSpell(s0680535_SummonBahloknehviirLocation)
	;target.RemoveSpell(VLSpell1)


ENDEVENT

EVENT OnUpdateGameTime()
	if (!Utility.IsInMenuMode())
		HoursPassed = GameTime2 - GameTime1
		s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() - (HoursPassed * (2000/s0680535_NPCExpMult.GetValue())))
		s0680535_BahloknehviirHungerPercent.SetValue(s0680535_BahloknehviirHunger.GetValue()/300 as int)
		s0680535_NPCExpMult.SetValue(s0680535_NPCExpMult.GetValue() - 1)  

		if(s0680535_BahloknehviirHunger.GetValue() < 2.0)
			s0680535_BahloknehviirHunger.SetValue(2.0)	;Prevents negative hunger values and enchantment doesn't function if it reaches zero
		endif
		
		if(s0680535_NPCExpMult.GetValue() < 1.0)
			s0680535_NPCExpMult.SetValue(1.0)
		endif

		s0680535_Rumors.SetValue(s0680535_Rumors.GetValue() - 0.05)
		if(s0680535_Rumors.GetValue() < 0)
			s0680535_Rumors.SetValue(0)
		endif
		
		;Just shows status updates
		if(s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01)
			if(s0680535_BahloknehviirHunger.GetValue() >= 29000.0)
			;ENGORGED THINGS
				BahloknehviirEngorged.Show()
			
			elseif((s0680535_BahloknehviirHunger.GetValue() < 29000.0) && (s0680535_BahloknehviirHunger.GetValue() >= 22000.0))
			;SATISFIED THINGS
				BahloknehviirSatisfied.Show()	

			elseif((s0680535_BahloknehviirHunger.GetValue() < 22000.0) && (s0680535_BahloknehviirHunger.GetValue() >= 15000.0))
			;UNSATISFIED THINGS
				BahloknehviirUnsatisfied.Show()

			elseif((s0680535_BahloknehviirHunger.GetValue() < 15000.0) && (s0680535_BahloknehviirHunger.GetValue() >= 7500.0))
			;HUNGRY THINGS
				BahloknehviirHungry.Show()

			elseif((s0680535_BahloknehviirHunger.GetValue() < 7500.0) && (s0680535_BahloknehviirHunger.GetValue() >= 3000.0))
			;RAVENOUS THINGS
				BahloknehviirRavenous.Show()

			elseif(s0680535_BahloknehviirHunger.GetValue() < 3000.0)
			;STARVED THINGS
				if (s0680535_BahloknehviirQuestUnspoken.GetStage() < 200)
					BahloknehviirStarved.Show()
				endif			
			endif
		endif
	endif
	GameTime1 = Utility.GetCurrentGameTime() * 24
	
	if Game.GetPlayer().HasMagicEffect(DevourerStart)
		RegisterForSingleUpdateGameTime(1.0)
	endif
ENDEVENT

Function BahloknehviirHungerManager(Actor Player)

	if((s0680535_BahloknehviirHunger.GetValue() >= 29000.0) && (s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01))
	;ENGORGED THINGS
		if(player.GetEquippedWeapon() == VM_DEVOURER)
			player.GetActorBase().SetEssential()	;When engorged, the blade will sustain you against anything
		else
			player.GetActorBase().SetEssential(FALSE)
		endif

	elseif((s0680535_BahloknehviirHunger.GetValue() < 29000.0) && (s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01))

		player.GetActorBase().SetEssential(FALSE)

		if((s0680535_BahloknehviirHunger.GetValue() <= 2.0) && (s0680535_BahloknehviirQuestUnspoken.GetStage() < 200))
			player.AddSpell(s0680535_DrainHealth, FALSE)
		else
			player.removespell(s0680535_DrainHealth)
		endif
	endif
EndFunction


Function BahloknehviirAbilityManager(actor player)

	if ((s0680535_SwordsmansJournal.GetReference().GetBaseObject() as book).IsRead() == 1) && (wordsknown.GetValue() == 0)
		Game.TeachWord(Bahlok)
		Game.TeachWord(Neh)
		Game.TeachWord(Viir)
		wordsknown.SetValue(1)
	endif
	
	if((s0680535_BahloknehviirVampireSouls.GetValue() >= 40) && (do1.GetValue() == 0))
		;Debug.Notification("Blackrazor")
		VampiricPower.Show()
		NewPowerGained.Show()
		do1.SetValue(1)

	elseif((s0680535_BahloknehviirVampireSouls.GetValue() >= 20) && (do2.GetValue() == 0))
		;Debug.Notification("Ethereal Bastion")
		VampiricPower.Show()
		NewPowerGained.Show()
		do2.SetValue(1)

	elseif((s0680535_BahloknehviirVampireSouls.GetValue() >= 10) && (do3.GetValue() == 0))
		;Debug.Notification("Unseen Eviscerator")
		VampiricPower.Show()
		NewPowerGained.Show()
		do3.SetValue(1)

	elseif((s0680535_BahloknehviirVampireSouls.GetValue() >= 5) && (do4.GetValue() == 0))
		;Debug.Notification("Sanguine Sundering")
		VampiricPower.Show()
		NewPowerGained.Show()
		do4.SetValue(1)
	endif

	if((s0680535_BahloknehviirDaedraSouls.GetValue() >= 40) && (do8.GetValue() == 0))
		;Debug.Notification("Soul Reaver")
		DaedricPower.Show()
		NewPowerGained.Show()
		do8.SetValue(1)

	elseif((s0680535_BahloknehviirDaedraSouls.GetValue() >= 20) && (do7.GetValue() == 0))
		;Debug.Notification("Daedric Shackles")
		DaedricPower.Show()
		NewPowerGained.Show()
		do7.SetValue(1)

	elseif((s0680535_BahloknehviirDaedraSouls.GetValue() >= 10) && (do6.GetValue() == 0))
		;Debug.Notification("Insatiable Predator")
		DaedricPower.Show()
		NewPowerGained.Show()
		do6.SetValue(1)

	elseif((s0680535_BahloknehviirDaedraSouls.GetValue() >= 5) && (do5.GetValue() == 0))
		;Debug.Notification("Daedric Laceration")
		DaedricPower.Show()
		NewPowerGained.Show()
		do5.SetValue(1)
	endif

	if((s0680535_BahloknehviirDragonSouls.GetValue() >= 40) && (do9.GetValue() == 0))
		;Debug.Notification("The Black Sword")
		DraconicPower.Show()
		NewPowerGained.Show()
		do9.SetValue(1)

	elseif((s0680535_BahloknehviirDragonSouls.GetValue() >= 20) && (do10.GetValue() == 0))
		;Debug.Notification("Draconic Hammer")
		DraconicPower.Show()
		do10.SetValue(1)

	elseif((s0680535_BahloknehviirDragonSouls.GetValue() >= 10) && (do11.GetValue() == 0))
		;Debug.Notification("Tyrannous Thu'um")
		DraconicPower.Show()
		NewPowerGained.Show()
		do11.SetValue(1)

	elseif((s0680535_BahloknehviirDragonSouls.GetValue() >= 5) && (do12.GetValue() == 0))
		;Debug.Notification("Elemental Censure")
		DraconicPower.Show()
		NewPowerGained.Show()
		do12.SetValue(1)
	endif

	if((s0680535_BahloknehviirDragonSouls.GetValue() >= 100) && (s0680535_BahloknehviirDaedraSouls.GetValue() >= 100) && (s0680535_BahloknehviirVampireSouls.GetValue() >= 100) && (wordsknown == true) && (do13.GetValue() == 0) && (s0680535_UnspokenStormActive.GetValue() == 1))
		;Debug.Notification("STORMBRINGER")
		BahloknehviirComplete.Show()
		NewPowerGained.Show()
		do13.SetValue(1)
	endif


; NOW HANDLED BY SOUL DEVOURER PERK
;	if(!player.HasPerk(s0680535_DevourerSight))
;		player.addperk(s0680535_DevourerSight)
;	endif
;	if(s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01)	 ;Awaken the blade!!
;		
;		if(s0680535_BahloknehviirAbilityUntouchable.GetValue() == 1)
;			player.AddPerk(s0680535_EtherealBastion)
;		elseif(s0680535_BahloknehviirAbilityUntouchable.GetValue() == 0)
;			player.RemovePerk(s0680535_EtherealBastion)
;		endif
;
;		if((s0680535_BahloknehviirAbilityMadness.GetValue() == 1) || (s0680535_BahloknehviirAbilityDraconicHammer.GetValue() == 1) || (s0680535_BahloknehviirAbilityDuaniikRah.GetValue() == 1))
;			player.AddPerk(s0680535_PullPerk)
;		elseif((s0680535_BahloknehviirAbilityMadness.GetValue() == 0) && (s0680535_BahloknehviirAbilityDraconicHammer.GetValue() == 0) && (s0680535_BahloknehviirAbilityDuaniikRah.GetValue() == 0))
;			player.RemovePerk(s0680535_PullPerk)
;		endif
;
;		if((s0680535_BahloknehviirAbilityMadness.GetValue() == 1) && (s0680535_BahloknehviirAbilitySoulReaver.GetValue() == 1) && (s0680535_BahloknehviirAbilityInsatiableWeapon.GetValue() == 1) && (s0680535_BahloknehviirAbilityDaedricLaceration.GetValue() == 1))
;			player.AddPerk(s0680535_OblivionMastery)
;		else
;			player.RemovePerk(s0680535_OblivionMastery)
;		endif
;	endif

EndFunction
