Scriptname s0680535_BahloknehviirIncrementDKs extends activemagiceffect  
{Controls dragon, daedra,vampire and NPC kill variables, disintigration and sword hunger}

import debug
import FormList

Actor Property PlayerActor  Auto  

GlobalVariable Property s0680535_DragonsKilledbyBahloknehviir  Auto  
GlobalVariable Property s0680535_BahloknehviirSouls  Auto  
GlobalVariable Property s0680535_BahloknehviirDaedraSouls  Auto  
GlobalVariable Property s0680535_BahloknehviirHunger  Auto  
GlobalVariable Property s0680535_BahloknehviirVampireSouls  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityInsatiableWeapon  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityTyrannousThuum  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityBlackrazor  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityUnstoppable  Auto  
GlobalVariable Property s0680535_BahloknehviirAbilityTheBlackSword  Auto
GlobalVariable Property s0680535_NPCKillMult  Auto  
GlobalVariable Property s0680535_NPCExpMult  Auto  
;GlobalVariable Property DragonsAbsorbed  Auto  

Keyword Property ActorTypeDragon  Auto  
Keyword Property ActorTypeNPC  Auto  
Keyword Property ActorTypeDaedra  Auto  
Keyword Property ActorTypeGhost  Auto  
Keyword Property Vampire  Auto  
Keyword Property ActorTypeDLC1Boss  Auto  

Quest Property s0680535_BahloknehviirQuest  Auto
Quest Property s0680535_BahloknehviirQuestUnspoken  Auto   

Race Property UnspokenRace  Auto  
Race Property RaceDremora  Auto  
Race Property ArgonianRace  Auto  
Race Property HighElfRace  Auto  
Race Property BretonRace  Auto  
Race Property WoodElfRace  Auto  
Race Property DarkElfRace  Auto  
Race Property OrcRace  Auto  
Race Property ImperialRace  Auto  
Race Property KhajiitRace  Auto  
Race Property NordRace  Auto  
Race Property RedguardRace  Auto  
Race Property AlduinRace  Auto  
Race Property DLC2MiraakRace  Auto  

ReferenceAlias Property DuaniikRah  Auto  

MiscObject Property SummonSwordMarker  Auto  

objectReference[] SwordSummoner

Faction Property DragonNoAbsorb  Auto  
Faction Property DLC2BenthicLurkerFaction  Auto  
Faction Property InstantKillImmunityFaction  Auto

WEAPON Property VM_DEVOURER  Auto  

;MagicEffect Property BahloknehviirReanimate  Auto  

Message Property NPCDevoured  Auto  
Message Property VampireDevoured  Auto  
Message Property DragonDevoured  Auto  
Message Property DaedraDevoured  Auto
Message Property ReanimateDevoured  Auto
Message Property s0680535_BahloknehviirDevouredFirstDragonSoul  Auto  
Message Property s0680535_BahloknehviirPerk  Auto  
Message Property s0680535_BahloknehviirDevourAlduin  Auto  
Message Property s0680535_BahloknehviirDevourHarkon  Auto  
Message Property s0680535_BahloknehviirDevourMiraak  Auto  
;Message Property UnspokenDevoured  Auto  

SPELL Property SoulTrap  Auto  
SPELL Property SoulTrap2  Auto  
SPELL Property SoulTrap3  Auto  
SPELL Property SoulTrap4  Auto  
SPELL Property AbilityInsatiableWeapon  Auto
SPELL Property AbilityTyrannousThuum  Auto  
SPELL Property s0680535_AltmerSoul  Auto  
SPELL Property s0680535_ArgonianSoul  Auto  
SPELL Property s0680535_BosmerSoul  Auto  
SPELL Property s0680535_BretonSoul  Auto  
SPELL Property s0680535_DunmerSoul  Auto  
SPELL Property s0680535_ImperialSoul  Auto  
SPELL Property s0680535_KhajiitSoul  Auto  
SPELL Property s0680535_NordSoul  Auto  
SPELL Property s0680535_RedguardSoul  Auto  
SPELL Property s0680535_OrsimerSoul  Auto  
SPELL Property s0680535_BahloknehviirSlowTime  Auto  
SPELL Property s0680535_ElementalCensure  Auto  
SPELL Property SummonSwordSpell Auto
SPELL Property s0680535_RumorMill  Auto  

Sound Property SwordScream  Auto  

ImageSpaceModifier Property DevourerIMod  Auto  
;Sound Property DevourerSoulSound  Auto  
EffectShader Property DevourerCasterFXS  Auto  
EffectShader Property DevourerTargetFXS  Auto  
VisualEffect Property DevourerCasterVFX  Auto  
VisualEffect Property DevourerTargetVFX  Auto  
VisualEffect Property SoulReaverVFX  Auto  
ImageSpaceModifier Property SoulReaverISM  Auto 

Actor victim
race VictimRace

EVENT OnEffectStart(ACTOR target, ACTOR caster)
	
	if ((target != none) && (caster != none))
		victim = target

		victim.DispelSpell(SoulTrap)
		victim.DispelSpell(SoulTrap2)
		victim.DispelSpell(SoulTrap3)
		victim.DispelSpell(SoulTrap4)

		if (Utility.RandomInt(1, 31500) > s0680535_BahloknehviirHunger.GetValue() as int)
			if(s0680535_BahloknehviirAbilityInsatiableWeapon.GetValue() == 1.0) ;Handle Insatiable Weapon ability
				AbilityInsatiableWeapon.Cast(caster, caster)
			endif
		endif

		if (Utility.RandomInt(1, 60000) < s0680535_BahloknehviirHunger.GetValue() as int)
			if(s0680535_BahloknehviirAbilityUnstoppable.GetValue() == 1.0) ;Handle Elemental Censure ability
				s0680535_ElementalCensure.Cast(caster, victim)
			endif
		endif
	
		if victim != PlayerActor	;Pariah has Stormbringer ability, probably best to disable instant-kill on player.
			If((Utility.RandomInt(1, 120000) <= (s0680535_BahloknehviirHunger.GetValue() as int)) && (s0680535_BahloknehviirAbilityTheBlackSword.GetValue() >= 1))	;Max 25% chance to kill at fully engorged
			;Apply this effect if the target is not in the excluded faction
				If victim.IsInFaction(InstantKillImmunityFaction) == 1
					victim.DamageActorValue("Health", 999)
				Else
					If caster.GetItemCount(VM_DEVOURER) >= 1
						victim.DamageActorValue("Health", 99999)
						SoulReaverVFX.Play(Target, 2, Caster)
						;SoulReaverISM.Apply(0.7)
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf

ENDEVENT

EVENT OnDying(ACTOR killer)
	if victim != none
		game.advanceskill("Conjuration", 0.1)

	if(victim == (DuaniikRah.GetReference() as actor))
		if killer == PlayerActor
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + 30000)
			;ReanimateDevoured.Show()
			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

			s0680535_BahloknehviirQuestUnspoken.SetStage(200)  
		endif
	elseif(victim.GetRace() == UnspokenRace)
		if killer == PlayerActor
			utility.wait(2)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + 30000)
			;UnspokenDevoured.Show()
			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

		endif
	elseif(victim.GetRace() == AlduinRace)
		if killer == PlayerActor
			utility.wait(2)
			s0680535_BahloknehviirDevourAlduin.Show()
			s0680535_DragonsKilledbyBahloknehviir.SetValue(s0680535_DragonsKilledbyBahloknehviir.GetValue() + 25)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*300))
			SwordScream.Play(killer)
			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

		endif
	
	elseif(victim.HasKeyword(ActorTypeDLC1Boss))
		if killer == PlayerActor
			utility.wait(5)
			s0680535_BahloknehviirDevourHarkon.Show()
			s0680535_BahloknehviirVampireSouls.SetValue(s0680535_BahloknehviirVampireSouls.GetValue() + 12.5)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*200))
			SwordScream.Play(killer)
			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

		endif

	elseif(victim.GetRace() == DLC2MiraakRace)
		if killer == PlayerActor
			utility.wait(5)
			s0680535_BahloknehviirDevourMiraak.Show()
			s0680535_DragonsKilledbyBahloknehviir.SetValue(s0680535_DragonsKilledbyBahloknehviir.GetValue() + 10)
			s0680535_BahloknehviirDaedraSouls.SetValue(s0680535_BahloknehviirDaedraSouls.GetValue() + 10)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*200))
			SwordScream.Play(killer)
			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

		endif

	elseif(victim.HasKeyword(ActorTypeDragon) && !victim.IsInFaction(DragonNoAbsorb))
		victim.AddToFaction(DragonNoAbsorb)
		if killer == PlayerActor
			if(s0680535_BahloknehviirQuest.GetStage() < 40)
				s0680535_BahloknehviirSlowTime.Cast(killer, killer)
				
				int index = 0

				while (index < 20)
					float zAng = victim.GetAngleZ()
					int zOffset = (victim.GetHeight() as int) + Utility.RandomInt(20,70)
					int yOffset = Utility.RandomInt(-600,600)
					int xOffset1 = Utility.RandomInt(-600,-300)
					int xOffset2 = Utility.RandomInt(600,300)

					SwordSummoner = new objectReference[20]
					SwordSummoner[index] = victim.PlaceAtMe(SummonSwordMarker)
					SwordSummoner[index].MoveTo(victim, xOffset1 * Math.Sin(zAng), yOffset * Math.Cos(zAng), zOffset)
					SwordSummoner[index].SetScale(0.35)
					;Utility.Wait(0.5)
					SummonSwordSpell.RemoteCast(SwordSummoner[index], killer, victim)
					Utility.Wait(0.2)
					index += 1
					
				endwhile
				
				DeathSequence(victim)
				OnKillAbilities(killer)
				Debug.Notification("Now awakened, with it's hunger unbound,")
				Utility.Wait(1)
				Debug.Notification("the blade will empower itself with intelligent souls.")

				s0680535_DragonsKilledbyBahloknehviir.SetValue(s0680535_DragonsKilledbyBahloknehviir.GetValue() + (victim.GetLevel()*0.02))
				s0680535_BahloknehviirQuest.SetStage(40)

				while (index != 0)
					if(SwordSummoner[index])
						SwordSummoner[index].InterruptCast()
						SwordSummoner[index].Delete()
						index -= 1
					endif
				endwhile

				killer.DispelSpell(s0680535_BahloknehviirSlowTime)
			else
				DragonDevoured.Show()
				s0680535_DragonsKilledbyBahloknehviir.SetValue(s0680535_DragonsKilledbyBahloknehviir.GetValue() + (victim.GetLevel() * (0.02 * s0680535_NPCExpMult.GetValue())))
				
			endif	
			
		endif
		
		s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*200))

		if killer != none
			killer.RestoreActorValue("Magicka", 250)

			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif
			
			OnKillAbilities(killer)
			DeathSequence(victim)
		endif

	elseif(victim.HasKeyword(ActorTypeDaedra) || victim.GetRace() == RaceDremora || victim.IsInFaction(DLC2BenthicLurkerFaction) == 1)
		if killer == PlayerActor
			DaedraDevoured.Show()
			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 0.01)	
				s0680535_BahloknehviirDaedraSouls.SetValue(s0680535_BahloknehviirDaedraSouls.GetValue() + (victim.GetLevel() * (0.02 * s0680535_NPCExpMult.GetValue())))
			endif
		endif
	
		if killer != none
			killer.RestoreActorValue("Magicka", 125)

			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*125))

			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

			OnKillAbilities(killer)
		endif

	elseif(victim.HasKeyword(Vampire))
		if killer == PlayerActor
			VampireDevoured.Show()
			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 0.01)	
				s0680535_BahloknehviirVampireSouls.SetValue(s0680535_BahloknehviirVampireSouls.GetValue() + (victim.GetLevel() * (0.02 * s0680535_NPCExpMult.GetValue())))
			endif
		endif
		
		if killer != none
			killer.RestoreActorValue("Magicka", 100)

			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*100))

			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

			OnKillAbilities(killer)
		endif

	elseif(victim.HasKeyword(ActorTypeNPC))
		if killer == PlayerActor
			NPCDevoured.Show()
			s0680535_BahloknehviirSouls.SetValue(s0680535_BahloknehviirSouls.GetValue() + (victim.GetLevel()* 0.02))
		endif
		
		if killer != none
			killer.RestoreActorValue("Magicka", 50)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() + (victim.GetLevel()*50))
			s0680535_NPCExpMult.SetValue(s0680535_NPCExpMult.GetValue() + 1)
		
			if(s0680535_NPCExpMult.GetValue() > 5.0)
				s0680535_NPCExpMult.SetValue(5.0)
			endif

			if (s0680535_BahloknehviirHunger.GetValue() > 30000.00)
				s0680535_BahloknehviirHunger.SetValue(30000.00)
			endif

			OnKillAbilities(killer)

			if (s0680535_BahloknehviirAbilityBlackrazor.GetValue() >= 1)
				if (victim.GetRace() == ArgonianRace)
					s0680535_ArgonianSoul.Cast(killer, killer)
				elseif (victim.GetRace() == HighElfRace)
					s0680535_AltmerSoul.Cast(killer, killer)
				elseif (victim.GetRace() == BretonRace)
					s0680535_BretonSoul.Cast(killer, killer)
				elseif (victim.GetRace() == WoodElfRace)
					s0680535_BosmerSoul.Cast(killer, killer)
				elseif (victim.GetRace() == DarkElfRace)
					s0680535_DunmerSoul.Cast(killer, killer)
				elseif (victim.GetRace() == OrcRace)
					s0680535_OrsimerSoul.Cast(killer, killer)
				elseif (victim.GetRace() == ImperialRace)
					s0680535_ImperialSoul.Cast(killer, killer)
				elseif (victim.GetRace() == NordRace)
					s0680535_NordSoul.Cast(killer, killer)
				elseif (victim.GetRace() == RedguardRace)
					s0680535_RedguardSoul.Cast(killer, killer)
				endif
			endif
		endif
	else
		if killer == PlayerActor
			killer.DamageActorValue("Magicka", 10)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() - (100 * s0680535_NPCExpMult.GetValue()))
			
			if (s0680535_BahloknehviirHunger.GetValue() < 2.00)
				s0680535_BahloknehviirHunger.SetValue(2.00)
			endif

			s0680535_NPCExpMult.SetValue(s0680535_NPCExpMult.GetValue() - 1)
			if(s0680535_NPCExpMult.GetValue() < 1.0)
				s0680535_NPCExpMult.SetValue(1.0)
			endif

			Debug.Notification("The hunger of the Black Sword grows.")
		endif
	endif
	
	if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 100) && (s0680535_BahloknehviirDaedraSouls.GetValue() >= 100) && (s0680535_BahloknehviirVampireSouls.GetValue() >= 100) && (s0680535_BahloknehviirQuest.GetStage() < 50)
		s0680535_BahloknehviirQuest.SetStage(50) ;SWORD IS FULLY RESTORED QUEST IS FINISHED
	endif
	endif
ENDEVENT

Function OnKillAbilities(ACTOR killer)

	if victim != none
		if killer == PlayerActor
			if(s0680535_BahloknehviirSouls.GetValue() >= (10 * s0680535_NPCKillMult.GetValue()))
				s0680535_BahloknehviirPerk.Show()
				Game.ModPerkPoints(1)
				s0680535_NPCKillMult.SetValue(s0680535_NPCKillMult.GetValue() + 2)
			endif
		endif

		if killer != none
			if(s0680535_BahloknehviirAbilityTyrannousThuum.GetValue() == 1.0) ;Handle Tyrannous Thu'um ability
				AbilityTyrannousThuum.Cast(killer, killer)
			endif
	
			if(s0680535_BahloknehviirAbilityBlackrazor.GetValue() == 1.0)
				if(victim.GetLevel() >= 40)
					killer.RestoreActorValue("Health", 99999)
					s0680535_BahloknehviirSlowTime.Cast(killer)
				endif
			endif
	
			;SOUL DEVOURER EFFECTS
			SwordScream.play(killer)       ; play SoundFX sound from player
			DevourerImod.apply()                                  ; apply isMod at full strength
			DevourerTargetVFX.Play(victim,4.7,killer)              ; Play TargetVFX and aim them at the player
			DevourerCasterVFX.Play(killer,5.9,victim)
			DevourerTargetFXS.Play(victim,2)    						; Play Effect Shaders
			DevourerCasterFXS.Play(killer,3)
			DevourerImod.Remove()

			if(killer.GetEquippedWeapon() == VM_DEVOURER)
				killer.ForceActorValue("rightitemcharge", s0680535_BahloknehviirHunger.GetValue())
			endif
	
			if(s0680535_DragonsKilledbyBahloknehviir.GetValue() >= 0.01)
				s0680535_RumorMill.Cast(killer)
			endif
		endif
	endif
EndFunction

Function DeathSequence(Actor dragonRef)
	
	if !dragonRef.IsInFaction(DragonNoAbsorb)
		dragonRef.AddToFaction(DragonNoAbsorb)
	endif

	; Add Skeleton to dragon's inventory.
	dragonRef.AddItem(DragonUnderskin)	

	; Dragon wings particles bits

	FXDragonDeathLHandBits.Play(dragonRef, 12)
	FXDragonDeathRHandBits.Play(dragonRef, 12)
	
	
	Utility.wait(0.2)
	
	;Equip skeleton under skin
	dragonRef.EquipItem(DragonUnderskin)
	Utility.wait(0.5)	
	dragonRef.PlaySubGraphAnimation("UnderSkinFadeOut")	
	
	;*** WORLD INTERACTION FUNCTION -- jduvall
	WI.PlayerIsCurrentlyAbsorbingPower(dragonRef)
	bIsAbsorbing = true
		
	; Start effect shader decorating holes in the base skin
	DragonHolesFXS.Play(dragonRef)
	; Play disintegrating skin.
	dragonRef.PlaySubGraphAnimation( "SkinFadeOut" )
;;;
	; Sound of dragon carcass first bursts into flames until the flames die off. Must be turned off
	int soundInstanceFireID = NPCDragonDeathSequenceFireLPM.play(dragonRef) 
	
	Utility.wait(1)
	
	;Small bits rising from dragon fx shader.
	DragonHolesBitsLiteFXS.Play(dragonRef)
	
	Utility.wait(1)
	;Bigger bits rising from dragon fx shader.
	DragonHolesBitsFXS.Play(dragonRef)
	
	Utility.wait(2)
	

	
	Utility.wait(1.75)
	;Play blood fade out if it is there
	dragonRef.PlaySubGraphAnimation("BloodFade")
	
	; Magic particles on wings
	FXDragonDeathRHandFire.Play(dragonRef, 12)
	FXDragonDeathLHandFire.Play(dragonRef, 12)
	
	Utility.wait(1.0)
	; magic fire fx shader
	DragonHolesMagicFXS.Play(dragonRef)
	DragonHolesMagicFXS.Stop(dragonRef);;;;;;;;;;;;;;;;;;;;;;;;

	Utility.wait(0.25)
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	;StopDragon bits fxs
	DragonHolesBitsFXS.Stop(dragonRef)
	DragonHolesBitsLiteFXS.Stop(dragonRef)		
	;Stop holes fx shader now that main dragon skin is un-worn
	DragonHolesFXS.Stop(dragonRef)
	
	; Play light emitting magic shader on dragon
;;	DragonHolesLightFXS.Play(dragonRef)

	Utility.wait(1.8)
	;unequipp invisible art
	if dragonRef.IsEquipped(DragonBloodHeadFXArmor) == true
		dragonRef.unEquipItem(DragonBloodHeadFXArmor)
	endif
	if dragonRef.IsEquipped(DragonBloodTailFXArmor) == true
		dragonRef.unEquipItem(DragonBloodTailFXArmor)
	endif
	if dragonRef.IsEquipped(DragonBloodWingLFXArmor) == true
		dragonRef.unEquipItem(DragonBloodWingLFXArmor)
	endif
	if dragonRef.IsEquipped(DragonBloodWingRFXArmor) == true
		dragonRef.unEquipItem(DragonBloodWingRFXArmor)
	endif
	
	Utility.wait(1.1)
	; turn off remaining effect bits and magic leak fxshaders

	
	Utility.wait(1)
	; ghost the dragon so you can't hit him
	;dragonRef.SetGhost(true)
		
	;clear any arrows that may have been stuck in dragon	
	dragonRef.clearExtraArrows()
	

;;

	Utility.wait(4)

	; End sound of dragon carcass bursting into flames.
	Sound.StopInstance(soundInstanceFireID)
	
	; add lingering smoke and glow to dragon carcass.
	DragonHolesSmokeFXS.Play(dragonRef)	
	
	; Start sound for smoldering dragon
	int soundInstanceSmolderID = NPCDragonDeathSequenceSmolderLPM.play(dragonRef) 

	Utility.wait(4)

	; turn off effect shaders for smoldering carcass
	DragonHolesSmokeFXS.Stop(dragonRef)
	
	Utility.wait(4)
	
	;Stop smoldering sound
	Sound.StopInstance(soundInstanceSmolderID)

	; put dragon in faction so other quests know player has absorbed power
	dragonRef.addtoFaction(MQKillDragonFaction)
	
	;Stop light emitting magic shader on dragon
	DragonHolesLightFXS.Stop(dragonRef)
	
	;*** WORLD INTERACTION FUNCTION -- jduvall
	WI.PlayerIsDoneAbsorbingPower(dragonRef)
	
	dragonRef.EquipItem(SkinDragonHider, true)
	
	bIsAbsorbing = false
	
endFunction

WIFunctionsScript Property WI Auto
{Pointer to WIFunctionsScript on WI quest. Used to call functions so that the dialogue in the scene in WIDragonKill quest is aware of when the player is aborbing and done absorbing the dragon's power.}

Armor Property DragonUnderskin  Auto   

Faction Property MQKillDragonFaction  Auto  

VisualEffect Property FXDragonDeathLHandBits Auto
VisualEffect Property FXDragonDeathLHandFire Auto
VisualEffect Property FXDragonDeathRHandBits Auto
VisualEffect Property FXDragonDeathRHandFire Auto
;VisualEffect Property DragonDeadswapHide  Auto
;VisualEffect Property DragonDeadswap Auto

EffectShader Property DragonHolesFXS Auto
EffectShader Property DragonHolesBitsFXS Auto
EffectShader Property DragonHolesBitsLiteFXS Auto
EffectShader Property DragonPowerAbsorbFXS Auto
EffectShader Property DragonHolesSmokeFXS Auto
EffectShader Property DragonHolesMagicFXS Auto
EffectShader Property DragonHolesLightFXS Auto

sound property NPCDragonDeathSequenceFireLPM auto
;sound property NPCDragonDeathSequenceWind auto
;sound property NPCDragonDeathSequenceExplosion auto
sound property NPCDragonDeathSequenceSmolderLPM auto

Armor Property DragonBloodHeadFXArmor  Auto  
Armor Property DragonBloodTailFXArmor  Auto  
Armor Property DragonBloodWingLFXArmor  Auto  
Armor Property DragonBloodWingRFXArmor  Auto  
Armor Property SkinDragonHider Auto

Explosion Property MAGDragonPowerAbsorbExplosion Auto

bool Property bIsAbsorbing  Auto  Conditional
{true while the absorb sequence is running}
