Scriptname s0680535_PickUpBlackSword extends ReferenceAlias

Activator Property s0680535_Marker  Auto  

ReferenceAlias Property BahloknehviirQuest  Auto  
ReferenceAlias Property s0680535_SwordsmanJournal  Auto  

Perk Property s0680535_DevourerPassives  Auto  

Quest Property s0680535_BahloknehviirQuest  Auto  

SPELL Property StopTime  Auto

WEAPON Property VM_DEVOURER Auto

ImageSpaceModifier Property DevourerIMod  Auto  
Sound Property DevourerSoulSound  Auto  
EffectShader Property DevourerCasterFXS  Auto  
EffectShader Property DevourerTargetFXS  Auto  
VisualEffect Property DevourerCasterVFX  Auto  
VisualEffect Property DevourerTargetVFX  Auto  

Bool Property GotSword Auto
Bool ImodApplied = false
Bool FXsApplied = false
float ImodStrength

Event OnInit()
	
	if self
		(self.GetReference() as actor).PathToReference(Game.GetPlayer(), 1)
	endif
EndEvent

Event OnDying(Actor killer)
	GotSword = false
	objectReference Vampire = self.GetReference()
	Vampire.RemoveItem(VM_DEVOURER)
	;Debug.Notification("Item Removed")
	
	objectReference SwordPlaced = Vampire.PlaceAtMe(s0680535_Marker)
	SwordPlaced.MoveTo(Vampire, 0, 0, Vampire.GetHeight())
	
	BahloknehviirQuest.ForceRefTo(SwordPlaced)
	;utility.wait(3)
	s0680535_BahloknehviirQuest.SetStage(20)
	RegisterForSingleUpdate(1)
	

ENDEvent

Event OnUpdate()
	objectReference SwordPlaced = BahloknehviirQuest.GetReference()
	objectReference killer = (self.GetReference() As Actor).GetKiller()

	if(s0680535_BahloknehviirQuest.GetStage() >= 30)
		DevourerImod.Remove()
		DevourerTargetVFX.Stop(killer)
		DevourerCasterVFX.Stop(killer)
		DevourerTargetFXS.Stop(killer)
		DevourerCasterFXS.Stop(killer)

		return

	elseif((killer.GetDistance(SwordPlaced) < 1000) && (GotSword == false))
		ImodStrength = 1 - (killer.GetDistance(SwordPlaced)/1000)

		;SOUL DEVOURER EFFECTS
		if ImodApplied == false
			DevourerImod.apply(ImodStrength)
			ImodApplied = true
		endif
		DevourerImod.PopTo(DevourerImod, ImodStrength)

		if FXsApplied == false
			DevourerTargetVFX.Play(Killer,2,SwordPlaced)              ; Play TargetVFX and aim them at the player
			DevourerCasterVFX.Play(killer,-1,SwordPlaced)
			DevourerTargetFXS.Play(SwordPlaced,-1)    		; Play Effect Shaders
			DevourerCasterFXS.Play(killer,-1)
			(killer as actor).DamageActorValue("Magicka", 70)
			FXsApplied = true
		endif
		RegisterForSingleUpdate(1)
		(killer as actor).DamageActorValue("Magicka", 70)
		DevourerTargetVFX.Play(Killer,2,SwordPlaced)

		utility.wait(1)
	elseif((killer.GetDistance(SwordPlaced) >= 1000) && (GotSword == false))
		DevourerImod.Remove()
		ImodApplied = false
		FXsApplied = false
		DevourerTargetVFX.Stop(killer)
		DevourerCasterVFX.Stop(killer)
		DevourerTargetFXS.Stop(killer)
		DevourerCasterFXS.Stop(killer)
		RegisterForSingleUpdate(1)
	endif
	
ENDEvent