Scriptname s0680535_VLremovespells extends ReferenceAlias  

SPELL Property VLSpellGalkin1  Auto  
SPELL Property VLSpellSummonBlackSword  Auto  
SPELL Property DLC1_VLrevert  Auto  
SPELL Property DLC1_VLTransform  Auto  
SPELL Property SummonBlackSword  Auto  
SPELL Property StopTimeOnDeath  Auto
SPELL Property Suppress  Auto  

GlobalVariable Property s0680535_BahloknehviirHunger  Auto
GlobalVariable Property s0680535_BahloknehviirDragonSouls  Auto

Race Property VampireLord  Auto
Race Property Werewolf  Auto

Message Property BahloknehviirSustains  Auto

MagicEffect Property SuppressMagicEffect  Auto  

Quest Property GalkinQuest  Auto
Quest Property s0680535_BahloknehviirQuest  Auto
Quest Property s0680535_BahloknehviirUnspokenQuest  Auto  

Keyword Property ActorTypeDragon  Auto  
Keyword Property Vampire  Auto  
Keyword Property ActorTypeNPC  Auto  
Keyword Property ActorTypeDaedra  Auto  

WEAPON Property VM_DEVOURER  Auto

ReferenceAlias Property MindspaceMarker  Auto  

ObjectReference Property XMarker1  Auto  

ImageSpaceModifier Property FadeToBlack  Auto  
;ImageSpaceModifier Property FadeIn  Auto  

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	
	actor wielder = self.GetReference() as actor
	if((s0680535_BahloknehviirQuest.GetStage() >= 40) && (s0680535_BahloknehviirUnspokenQuest.GetStage() < 100) && !wielder.HasMagicEffect(SuppressMagicEffect))
		if(akAggressor != none)
			;Debug.Notification("Player was hit")
			if(akAggressor.HasKeyword(ActorTypeDragon) || akAggressor.HasKeyword(ActorTypeDaedra) || akAggressor.HasKeyword(Vampire) || akAggressor.HasKeyword(ActorTypeNPC))
				;Debug.Notification("Aggressor is consumable")

				if(s0680535_BahloknehviirHunger.GetValue() < 3000) && (s0680535_BahloknehviirUnspokenQuest.GetStage() != 200)
					;Debug.Notification("sword is hungry")

					if((akProjectile == none) && (wielder.GetEquippedWeapon() != VM_DEVOURER) && (wielder.GetRace() != VampireLord) && (wielder.GetRace() != Werewolf))
						if(Utility.RandomInt(1,5) == 1)
							Game.DisablePlayerControls()
							SummonBlackSword.Cast(wielder as objectreference,wielder as objectreference)
							Debug.Notification("Hunger overwhelms. The Sword comes without being called.")
							Game.EnablePlayerControls()
						endif
					endif
				endif
			endif
		endif
	endif
endevent


Event OnSpellCast(Form akSpell)
	Spell spellCast = akSpell as Spell
	if spellCast == DLC1_VLrevert
		(self.GetReference() as actor).RemoveSpell(VLSpellGalkin1)
		(self.GetReference() as actor).RemoveSpell(VLSpellSummonBlackSword)

	elseif spellCast == DLC1_VLTransform
		if(s0680535_BahloknehviirQuest.GetStage() >= 30)
			(self.GetReference() as actor).AddSpell(VLSpellSummonBlackSword, false)	;Adds Summon Black Sword (location) to VL
		endif

		if(GalkinQuest.GetStage() >= 200)
			(self.GetReference() as actor).AddSpell(VLSpellGalkin1, false)				;Adds Hemorrhagic Wave to VL
		endif
	
	elseif spellCast == Suppress
		s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() - 2500.0)
	endif
endEvent

Event OnEnterBleedout()
	if(s0680535_BahloknehviirUnspokenQuest.GetStage() == 100)
		FadetoBlack.Apply()
		Game.GetPlayer().MoveTo(XMarker1)
		s0680535_BahloknehviirUnspokenQuest.SetStage(110)
		FadetoBlack.Remove()

	elseif(s0680535_BahloknehviirHunger.GetValue() >= 29000.0)
		actor wielder = (self.GetReference() as actor)
		if( (s0680535_BahloknehviirDragonSouls.GetValue() >= 0.01) && (wielder.GetEquippedWeapon() == VM_DEVOURER))

			;Debug.Trace("We entered bleedout...")
			StopTimeOnDeath.Cast(self.GetReference())
			BahloknehviirSustains.Show()
			wielder.RestoreActorValue("Health", 99999)
			s0680535_BahloknehviirHunger.SetValue(s0680535_BahloknehviirHunger.GetValue() - 15000.0)		;Completely heals the player, but leaves the sword hungry
		endif
	endif
endEvent
